﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Media;
using System.Windows.Threading;
using WpfBreakout.Bricks;
using System.Windows.Controls;

namespace WpfBreakout.PowerUps
{
    public class Bonus : UIElement
    {
        // private Fields
        internal DrawingVisual _bonus;
        internal const double _radiusX = 5;
        internal const double _radiusY = 5;

        DispatcherTimer time;
        MainWindow mainWindow;

        public Bonus(Brick brick, MainWindow window)
        {
            _bonus = new DrawingVisual();
            DrawingContext context = _bonus.RenderOpen();
            context.DrawEllipse(Brushes.Yellow, new Pen(Brushes.Black, 1.0), new Point(0, 0), _radiusX, _radiusY);
            context.Close();

            this.SetValue(Canvas.TopProperty, Canvas.GetTop(brick));
            this.SetValue(Canvas.LeftProperty, Canvas.GetLeft(brick));

            mainWindow = window;
            time = window.timer;
            time.Tick += new EventHandler(time_Tick);
        }

        void time_Tick(object sender, EventArgs e)
        {
            this.SetValue(Canvas.TopProperty, Canvas.GetTop(this) + _radiusX);

            if (Canvas.GetTop(this) > mainWindow.GameCanvas.Height)
                mainWindow.GameCanvas.Children.Remove(this);

            //CheckPaddleCollision();
        }


        void CheckPaddleCollision()
        {
            
            //double pTop = Canvas.GetTop(mainWindow.paddle);
            //double pLeft = Canvas.GetLeft(mainWindow.paddle);

            //if (pLeft < Canvas.GetLeft(this))
            //    return;
            //else if (ball.Position.X < this.Left)
            //    return Collision.Left;
            //else if (ball.Position.Y > this.Bottom)
            //    return Collision.Bottom;
            //else if (ball.Position.Y < this.Top)
            //    return Collision.Top;
        }

        // overrides from Visual class
        protected override int VisualChildrenCount
        {
            get { return 1; }
        }
        protected override Visual GetVisualChild(int index)
        {
            if (index != 0)
            {
                throw new ArgumentOutOfRangeException();
            }

            return _bonus;
        }
    }
}
